<?php
// $Id: callback.inc,v 1.1.2.2 2011/01/09 18:26:22 smoothify Exp $

/**
 * The AHAH callback.
 */
function dependent_fields_callback($type_name, $field_name, $delta) {
  module_load_include('inc', 'dependent_fields', 'includes/form');
  $field = content_fields($field_name, $type_name);
  $type = (array)content_types($type_name);

  $form_state = array('storage' => NULL, 'submitted' => FALSE);

  $form_build_id = $_POST['form_build_id'];

  $form = form_get_cache($form_build_id, $form_state);

  if (!$form) {
    // Invalid form_build_id.
    drupal_set_message(t('An unrecoverable error occurred. This form was missing from the server cache. Try reloading the page and submitting again.'), 'error');
    print drupal_to_js(array('data' => theme('status_messages')));
    exit;
  }

  $args = $form['#parameters'];
  $form_id = array_shift($args);
  $form_state['post'] = $form['#post'] = $_POST;

  // Enable the submit/validate handlers to determine whether AHAH-submittted.
  $form_state['ahah_submission'] = TRUE;
  $form_state['ahah_controller'] = $field_name;
  $form_state['ahah_controlled'] = array();

  $form['#programmed'] = $form['#redirect'] = FALSE;

  $form_state['values'] = array();

  $form = form_builder($form_id, $form, $form_state);

  $form_element = dependent_fields_get_ahah_wrapper_element($form, $field, $type);

  // Since the after build functions don't seem to run in some cck fields form, lets
  // run it on our form element.

  dependent_fields_callback_after_build($form_element, $form_state);

  unset($form_element['#prefix'], $form_element['#suffix']);

  if (isset($form_element['_weight'])) {
    unset($form_element['_weight']);
  }

  // Render our form element
  $output = drupal_render($form_element);

  // TODO: Check we actually have multi level elements, so we only apply when required.
  // When we are using multi level dependencies, where a controlled field is also
  // a controller, the AHAH settings get lost so we need to reapply

  // Loop through the JS settings and find the settings needed for our fields.
  $javascript = drupal_add_js(NULL, NULL);
  $dependent_field_ahah_settings = array();
  if (isset($javascript['setting'])) {
    foreach ($javascript['setting'] as $settings) {
      if (isset($settings['ahah'])) {
        foreach ($settings['ahah'] as $id => $ahah_settings) {
          $url = $ahah_settings['url'];
          if (strpos($url, 'dependent_fields/callback')) {
            $dependent_field_ahah_settings[$id] = $ahah_settings;
          }
        }
      }
    }
  }

  // Add the AHAH settings needed for our new buttons.
  if (!empty($dependent_field_ahah_settings)) {
    $output .= '<script type="text/javascript">jQuery.extend(Drupal.settings.ahah, '. drupal_to_js($dependent_field_ahah_settings) .');</script>';
  }

  // Include any status messages (unlikely as we have disabled validation)
  $output = theme('status_messages') . $output;

  drupal_json(array(
    'status'   => TRUE,
    'data'     => $output,
  ));

  exit();
}
